From a83247c5a3d79a414015ebda9108fb3400919849 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:11 +0000
Subject: [PATCH 394/2232] Rename std$vector$T$length to match std::vector<T>::size


---

diff --git a/gen/write.rs b/gen/write.rs
index c1aa2f7..3da42b3 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -1131,7 +1131,7 @@ fn write_vector(out: &mut OutFile, ident: &Ident) {
     writeln!(out, "#define CXXBRIDGE02_vector_{}", instance);
     writeln!(
         out,
-        "size_t cxxbridge02$std$vector${}$length(const ::std::vector<{}> &s) noexcept {{",
+        "size_t cxxbridge02$std$vector${}$size(const ::std::vector<{}> &s) noexcept {{",
         instance, inner,
     );
     writeln!(out, "  return s.size();");
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index be23fcf..b2278e0 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -650,7 +650,7 @@ fn expand_vector(namespace: &Namespace, ty: &Type) -> TokenStream {
     let inner = ty;
     let mangled = ty.to_mangled(&namespace.segments) + "$";
     let prefix = format!("cxxbridge02$std$vector${}", mangled);
-    let link_length = format!("{}length", prefix);
+    let link_size = format!("{}size", prefix);
     let link_get_unchecked = format!("{}get_unchecked", prefix);
     let link_push_back = format!("{}push_back", prefix);
 
@@ -666,7 +666,7 @@ fn expand_vector(namespace: &Namespace, ty: &Type) -> TokenStream {
             fn __vector_size(v: &::cxx::CxxVector<#inner>) -> usize {
                 unsafe {
                     extern "C" {
-                        #[link_name = #link_length]
+                        #[link_name = #link_size]
                         fn __vector_size(_: &::cxx::CxxVector<#inner>) -> usize;
                     }
                     __vector_size(v)
@@ -691,7 +691,7 @@ pub fn impl_vector_element_for_primitive(ident: Ident) -> TokenStream {
     let namespace = Namespace { segments: vec![] };
     let mangled = ty.to_mangled(&namespace.segments) + "$";
     let prefix = format!("cxxbridge02$std$vector${}", mangled);
-    let link_length = format!("{}length", prefix);
+    let link_size = format!("{}size", prefix);
     let link_get_unchecked = format!("{}get_unchecked", prefix);
     let link_push_back = format!("{}push_back", prefix);
 
@@ -707,7 +707,7 @@ pub fn impl_vector_element_for_primitive(ident: Ident) -> TokenStream {
             fn __vector_size(v: &CxxVector<#inner>) -> usize {
                 unsafe {
                     extern "C" {
-                        #[link_name = #link_length]
+                        #[link_name = #link_size]
                         fn __vector_size(_: &CxxVector<#inner>) -> usize;
                     }
                     __vector_size(v)
diff --git a/src/cxx.cc b/src/cxx.cc
index a0e92ac..15f888d 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -201,7 +201,7 @@ void cxxbridge02$unique_ptr$std$string$drop(
 
 #define STD_VECTOR_OPS(RUST_TYPE, CXX_TYPE)                                    \
   extern "C" {                                                                 \
-  size_t cxxbridge02$std$vector$##RUST_TYPE##$length(                          \
+  size_t cxxbridge02$std$vector$##RUST_TYPE##$size(                            \
       const std::vector<CXX_TYPE> &s) noexcept {                               \
     return s.size();                                                           \
   }                                                                            \

